package action;

import java.util.List;

import org.jbpm.JbpmConfiguration;
import org.jbpm.JbpmContext;
import org.jbpm.db.GraphSession;
import org.jbpm.graph.def.ProcessDefinition;
import org.jbpm.graph.exe.ProcessInstance;
import org.jbpm.taskmgmt.exe.TaskInstance;

public class AllMethods {

	static  AllMethods allMethods = null;
	private JbpmContext jbpmContext = null;
	private JbpmConfiguration jbpmConfiguration=null;  
	public AllMethods() {
	    	jbpmConfiguration = JbpmConfiguration.getInstance();
	    }

	    public static AllMethods getInstance(){
	    if(allMethods == null ) allMethods = new AllMethods();
	    return allMethods;	
	    }

	    
public String reDeployProcess(String processName) 
	{   
		jbpmConfiguration = JbpmConfiguration.parseResource("jbpm.cfg.xml");
		JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();  
		System.out.println("1");
		ProcessDefinition processDefinition = ProcessDefinition.parseXmlResource(processName);  
		System.out.println("2");
		System.out.println(processDefinition);
		jbpmContext.deployProcessDefinition(processDefinition);  
		System.out.println("3");
		System.out.println("prcoess getting deployed is :"+processDefinition.getName());
		jbpmContext.close();
		System.out.println(processDefinition.getName());
		return processDefinition.getName();
		
	
	}

public String startNewProcessInstance(String processDefinitionName) 
{
JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();  
GraphSession graphSession = jbpmContext.getGraphSession();  
ProcessDefinition definition = graphSession.findLatestProcessDefinition(processDefinitionName);  
System.out.println("definition is "+definition);
ProcessInstance instance = definition.createProcessInstance();  
long id = instance.getId();  
instance.signal();
jbpmContext.save(instance);  
jbpmContext.close();
return ""+id;  
}


public List<?> listAllTasks(String User)
{
JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();
jbpmContext.setActorId(User);
System.out.println(jbpmContext.getActorId());
List<?> list =  jbpmContext.getTaskList(User); 
System.out.println(list.size());
//TaskInstance taskInstance =null;
//taskInstance.end();
return list;
}



public String signalProcess(String processDefinitionName, String id) {  
	JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();  

	long processId = Long.parseLong(id);  
	ProcessInstance instance = jbpmContext.loadProcessInstance(processId);  
	instance.signal(); 
	jbpmContext.save(instance);  
	jbpmContext.close(); 
	return "process signalled" ;
}


	
	public String completeProcess(String processDefinitionName, String id, String User) {  
		JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();  

		long processId = Long.parseLong(id);
		ProcessInstance instance = jbpmContext.loadProcessInstance(processId);  
		TaskInstance taskInstance = (TaskInstance)  
	      instance.getTaskMgmtInstance().getTaskInstances().iterator().next();
		System.out.println(taskInstance);
		System.out.println(taskInstance.getActorId());
		taskInstance.end();
		jbpmContext.save(instance);  
		jbpmContext.close(); 
	
		return "process signalled" ;
	}
	
	
	public String completeProcessWithTransition(String processDefinitionName, String id, String User, String transition) {  
		JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();  

		long processId = Long.parseLong(id);  
		ProcessInstance instance = jbpmContext.loadProcessInstance(processId);  
		TaskInstance taskInstance = (TaskInstance)  
	      instance.getTaskMgmtInstance().getTaskInstances().iterator().next();
		System.out.println(taskInstance);
		System.out.println(taskInstance.getActorId());
		taskInstance.end(transition);
		System.out.println("Instance has ended? "+instance.hasEnded());
		jbpmContext.save(instance);  
		jbpmContext.close(); 
	
		return "process signalled" ;
	}
	
public String signalProcessWithTransition(String processDefinitionName, String id, String transitionName) {  
	JbpmContext jbpmContext = jbpmConfiguration.createJbpmContext();  

	long processId = Long.parseLong(id);  
	ProcessInstance instance = jbpmContext.loadProcessInstance(processId);  
	instance.signal(transitionName); 
	jbpmContext.save(instance);  
	jbpmContext.close();  
	return "process signalled" ;
	}
}
